# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`postfixadmin`](#postfixadmin): Postfixadmin main class
* [`postfixadmin::cli::params`](#postfixadmin--cli--params): Class to set the postfixadmin client program to use  Parameters:
* [`postfixadmin::config`](#postfixadmin--config): class for postfixadmin configuration
* [`postfixadmin::db`](#postfixadmin--db): install database
* [`postfixadmin::db::mysql`](#postfixadmin--db--mysql): privat class to manage mysql db use postfixadmin::db instead
* [`postfixadmin::fix_debian_bug`](#postfixadmin--fix_debian_bug): This fixes debian bug #856338  see: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=856338
* [`postfixadmin::install`](#postfixadmin--install): install packages
* [`postfixadmin::queries::dovecot`](#postfixadmin--queries--dovecot): class to create mysql maps for postfix  Parameters:
* [`postfixadmin::queries::postfix`](#postfixadmin--queries--postfix): class to create mysql maps for postfix
* [`postfixadmin::vhost`](#postfixadmin--vhost): This class chooses the type of vhost to run webserver
* [`postfixadmin::vhost::apache`](#postfixadmin--vhost--apache): internal class that installs an apache vhost Parameters are inherited from postfixadmin::vhost

### Defined types

* [`postfixadmin::cli::create_admin`](#postfixadmin--cli--create_admin): This define just ensures that a an admin account exists.
* [`postfixadmin::cli::create_aliasdomain`](#postfixadmin--cli--create_aliasdomain): define to ensure an aliasdomain exists
* [`postfixadmin::cli::create_domain`](#postfixadmin--cli--create_domain): Ensures, that a domain exists But does not modify any domains
* [`postfixadmin::domain`](#postfixadmin--domain): helper define to create domains

### Functions

* [`postfixadmin_generate_pw`](#postfixadmin_generate_pw): computes a random password string

## Classes

### <a name="postfixadmin"></a>`postfixadmin`

Postfixadmin main class

#### Parameters

The following parameters are available in the `postfixadmin` class:

* [`ensure_database`](#-postfixadmin--ensure_database)
* [`ensure_vhost`](#-postfixadmin--ensure_vhost)
* [`ensure_postfix_queries`](#-postfixadmin--ensure_postfix_queries)
* [`ensure_dovecot_queries`](#-postfixadmin--ensure_dovecot_queries)
* [`admins`](#-postfixadmin--admins)
* [`domains`](#-postfixadmin--domains)
* [`aliasdomains`](#-postfixadmin--aliasdomains)
* [`dovecot_classes`](#-postfixadmin--dovecot_classes)
* [`postfix_classes`](#-postfixadmin--postfix_classes)

##### <a name="-postfixadmin--ensure_database"></a>`ensure_database`

Data type: `Boolean`

if true a database is created
Defaults to false

Default value: `false`

##### <a name="-postfixadmin--ensure_vhost"></a>`ensure_vhost`

Data type: `Boolean`

if true a virtualhost is created
Defaults to false

Default value: `false`

##### <a name="-postfixadmin--ensure_postfix_queries"></a>`ensure_postfix_queries`

Data type: `Boolean`

if true the maps querying the database
for postfix are created
Defaults to false

Default value: `false`

##### <a name="-postfixadmin--ensure_dovecot_queries"></a>`ensure_dovecot_queries`

Data type: `Boolean`

if true the maps querying the database
for dovecot are created
Defaults to false

Default value: `false`

##### <a name="-postfixadmin--admins"></a>`admins`

Data type: `Hash`

Hash of hashes to create postfixadmin::cli::create_admin
Defaults to {}

Default value: `{}`

##### <a name="-postfixadmin--domains"></a>`domains`

Data type: `Hash`

Hash of hases to create postfixadmin::cli::create_domain
Defaults to {}

Default value: `{}`

##### <a name="-postfixadmin--aliasdomains"></a>`aliasdomains`

Data type: `Hash`

Hash of hases to create postfixadmin::cli::create_aliasdomain
Defaults to {}

Default value: `{}`

##### <a name="-postfixadmin--dovecot_classes"></a>`dovecot_classes`

Data type: `Array`

Array of classnames that are required for devecot
query installation (defaults to ['dovecot'])

Default value: `['dovecot']`

##### <a name="-postfixadmin--postfix_classes"></a>`postfix_classes`

Data type: `Array`

Array of classnames that are required for postfix
query installation (defaults to ['postfix'])

Default value: `['postfix']`

### <a name="postfixadmin--cli--params"></a>`postfixadmin::cli::params`

Class to set the postfixadmin client program to use

Parameters:

#### Parameters

The following parameters are available in the `postfixadmin::cli::params` class:

* [`path`](#-postfixadmin--cli--params--path)
* [`cmd`](#-postfixadmin--cli--params--cmd)

##### <a name="-postfixadmin--cli--params--path"></a>`path`

Data type: `Array`



Default value: `['/bin','/usr/bin']`

##### <a name="-postfixadmin--cli--params--cmd"></a>`cmd`

Data type: `String`

the postfixadmin-cli program
defaults to:
'bash /usr/share/postfixadmin/scripts/postfixadmin-cli'

Default value: `'bash /usr/share/postfixadmin/scripts/postfixadmin-cli'`

### <a name="postfixadmin--config"></a>`postfixadmin::config`

class for postfixadmin configuration

#### Parameters

The following parameters are available in the `postfixadmin::config` class:

* [`config_file`](#-postfixadmin--config--config_file)
* [`configs`](#-postfixadmin--config--configs)
* [`owner`](#-postfixadmin--config--owner)
* [`group`](#-postfixadmin--config--group)
* [`mode`](#-postfixadmin--config--mode)

##### <a name="-postfixadmin--config--config_file"></a>`config_file`

Data type: `String`

configuration file to use

Default value: `'/etc/postfixadmin/config.local.php'`

##### <a name="-postfixadmin--config--configs"></a>`configs`

Data type: `Hash`

Hash of configuration variables to set.
Defaults to {}

Default value: `{}`

##### <a name="-postfixadmin--config--owner"></a>`owner`

Data type: `String`

configfile owner

Default value: `'root'`

##### <a name="-postfixadmin--config--group"></a>`group`

Data type: `String`

configfile group

Default value: `'www-data'`

##### <a name="-postfixadmin--config--mode"></a>`mode`

Data type: `String`

configfile mode

Default value: `'0640'`

### <a name="postfixadmin--db"></a>`postfixadmin::db`

install database

#### Parameters

The following parameters are available in the `postfixadmin::db` class:

* [`dbpass`](#-postfixadmin--db--dbpass)
* [`dbtype`](#-postfixadmin--db--dbtype)
* [`dbname`](#-postfixadmin--db--dbname)
* [`dbuser`](#-postfixadmin--db--dbuser)
* [`basepath`](#-postfixadmin--db--basepath)
* [`dbport`](#-postfixadmin--db--dbport)
* [`host`](#-postfixadmin--db--host)
* [`host_config`](#-postfixadmin--db--host_config)
* [`dbconfig_inc`](#-postfixadmin--db--dbconfig_inc)

##### <a name="-postfixadmin--db--dbpass"></a>`dbpass`

Data type: `String`

password to connect to the database.

Default value: `'CHANGEME'`

##### <a name="-postfixadmin--db--dbtype"></a>`dbtype`

Data type: `String`

database type to use currently mysql or mysqli
is supported.

Default value: `'mysql'`

##### <a name="-postfixadmin--db--dbname"></a>`dbname`

Data type: `String`

name of the database
defaults to: 'postfixadmin'

Default value: `'postfixadmin'`

##### <a name="-postfixadmin--db--dbuser"></a>`dbuser`

Data type: `String`

username to connect to the database.
defaults to: 'postfixadmin'

Default value: `'postfixadmin'`

##### <a name="-postfixadmin--db--basepath"></a>`basepath`

Data type: `Optional[String[1]]`

basepath for database, defaults to undef

Default value: `undef`

##### <a name="-postfixadmin--db--dbport"></a>`dbport`

Data type: `String`

port to connect to db defaults to '3306' (mysql)

Default value: `'3306'`

##### <a name="-postfixadmin--db--host"></a>`host`

Data type: `String`

host that is allowed to connect for database creation
defaults to 'localhost'

Default value: `'localhost'`

##### <a name="-postfixadmin--db--host_config"></a>`host_config`

Data type: `Optional[String]`

host that is used to connect to database
defaults to same as host.

Default value: `undef`

##### <a name="-postfixadmin--db--dbconfig_inc"></a>`dbconfig_inc`

Data type: `String`

where to write the db config.
defaults to '/etc/postfixadmin/dbconfig.inc.php'
if you do not want to write, set it to ''

Default value: `'/etc/postfixadmin/dbconfig.inc.php'`

### <a name="postfixadmin--db--mysql"></a>`postfixadmin::db::mysql`

privat class to manage mysql db
use postfixadmin::db instead

#### Parameters

The following parameters are available in the `postfixadmin::db::mysql` class:

* [`dbname`](#-postfixadmin--db--mysql--dbname)
* [`dbuser`](#-postfixadmin--db--mysql--dbuser)
* [`dbpass`](#-postfixadmin--db--mysql--dbpass)
* [`host`](#-postfixadmin--db--mysql--host)
* [`collate`](#-postfixadmin--db--mysql--collate)
* [`charset`](#-postfixadmin--db--mysql--charset)

##### <a name="-postfixadmin--db--mysql--dbname"></a>`dbname`

Data type: `String`

name of the database

Default value: `$postfixadmin::db::dbname`

##### <a name="-postfixadmin--db--mysql--dbuser"></a>`dbuser`

Data type: `String`

username to access the database

Default value: `$postfixadmin::db::dbuser`

##### <a name="-postfixadmin--db--mysql--dbpass"></a>`dbpass`

Data type: `String`

password for the database

Default value: `$postfixadmin::db::dbpass`

##### <a name="-postfixadmin--db--mysql--host"></a>`host`

Data type: `String`

hostname

Default value: `$postfixadmin::db::host`

##### <a name="-postfixadmin--db--mysql--collate"></a>`collate`

Data type: `Optional[String[1]]`

collate for the database

Default value: `undef`

##### <a name="-postfixadmin--db--mysql--charset"></a>`charset`

Data type: `Optional[String[1]]`

charset for the database

Default value: `undef`

### <a name="postfixadmin--fix_debian_bug"></a>`postfixadmin::fix_debian_bug`

This fixes debian bug #856338

see:
https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=856338

#### Parameters

The following parameters are available in the `postfixadmin::fix_debian_bug` class:

* [`docroot`](#-postfixadmin--fix_debian_bug--docroot)

##### <a name="-postfixadmin--fix_debian_bug--docroot"></a>`docroot`

Data type: `String`

the document root

Default value: `'/usr/share/postfixadmin'`

### <a name="postfixadmin--install"></a>`postfixadmin::install`

install packages

#### Parameters

The following parameters are available in the `postfixadmin::install` class:

* [`package_name`](#-postfixadmin--install--package_name)
* [`packages`](#-postfixadmin--install--packages)
* [`package_ensure`](#-postfixadmin--install--package_ensure)

##### <a name="-postfixadmin--install--package_name"></a>`package_name`

Data type: `String`

name of the package to install

Default value: `'postfixadmin'`

##### <a name="-postfixadmin--install--packages"></a>`packages`

Data type: `Array`

additional packages to install

Default value: `[]`

##### <a name="-postfixadmin--install--package_ensure"></a>`package_ensure`

Data type: `String`

what to ensure for packages

Default value: `'installed'`

### <a name="postfixadmin--queries--dovecot"></a>`postfixadmin::queries::dovecot`

class to create mysql maps for postfix

Parameters:

#### Parameters

The following parameters are available in the `postfixadmin::queries::dovecot` class:

* [`dbpass`](#-postfixadmin--queries--dovecot--dbpass)
* [`dbuser`](#-postfixadmin--queries--dovecot--dbuser)
* [`dbname`](#-postfixadmin--queries--dovecot--dbname)
* [`host`](#-postfixadmin--queries--dovecot--host)
* [`mysql_flags`](#-postfixadmin--queries--dovecot--mysql_flags)
* [`dir`](#-postfixadmin--queries--dovecot--dir)
* [`owner`](#-postfixadmin--queries--dovecot--owner)
* [`group`](#-postfixadmin--queries--dovecot--group)
* [`mode`](#-postfixadmin--queries--dovecot--mode)
* [`default_password_scheme`](#-postfixadmin--queries--dovecot--default_password_scheme)
* [`mboxpath`](#-postfixadmin--queries--dovecot--mboxpath)
* [`uid`](#-postfixadmin--queries--dovecot--uid)
* [`gid`](#-postfixadmin--queries--dovecot--gid)
* [`quota`](#-postfixadmin--queries--dovecot--quota)

##### <a name="-postfixadmin--queries--dovecot--dbpass"></a>`dbpass`

Data type: `String`

password to connect to the database.

Default value: `'CHANGEME'`

##### <a name="-postfixadmin--queries--dovecot--dbuser"></a>`dbuser`

Data type: `String`

username to connect to the database.
defaults to: 'postfixadmin'

Default value: `'postfixadmin'`

##### <a name="-postfixadmin--queries--dovecot--dbname"></a>`dbname`

Data type: `String`

name of the database
defaults to: 'postfixadmin'

Default value: `'postfixadmin'`

##### <a name="-postfixadmin--queries--dovecot--host"></a>`host`

Data type: `String`

host to connect to.
defaults to localhost

Default value: `'localhost'`

##### <a name="-postfixadmin--queries--dovecot--mysql_flags"></a>`mysql_flags`

Data type: `Array`

Array of additional flags for connecting to mysql
eg. ssl settings. defaults to []

Default value: `[]`

##### <a name="-postfixadmin--queries--dovecot--dir"></a>`dir`

Data type: `String`

directory to place the map

Default value: `'/etc/dovecot/postfixadmin'`

##### <a name="-postfixadmin--queries--dovecot--owner"></a>`owner`

Data type: `String`

owner of the map files

Default value: `'root'`

##### <a name="-postfixadmin--queries--dovecot--group"></a>`group`

Data type: `String`

group of the map files

Default value: `'root'`

##### <a name="-postfixadmin--queries--dovecot--mode"></a>`mode`

Data type: `String`

mode of the map files

Default value: `'0640'`

##### <a name="-postfixadmin--queries--dovecot--default_password_scheme"></a>`default_password_scheme`

Data type: `String`

change to match your Postfixadmin setting.
depends on your $CONF['encrypt'] setting
defaults to 'MD5-CRYPT'

Default value: `'MD5-CRYPT'`

##### <a name="-postfixadmin--queries--dovecot--mboxpath"></a>`mboxpath`

Data type: `Optional[String[1]]`

path to the mbailboxes
defaults to undef

Default value: `undef`

##### <a name="-postfixadmin--queries--dovecot--uid"></a>`uid`

Data type: `Optional[String[1]]`

uid to use for mailboxes
must matche dovecot.conf AND Postfix virtual_uid_maps parameter
defaults to undef (not included in query)

Default value: `undef`

##### <a name="-postfixadmin--queries--dovecot--gid"></a>`gid`

Data type: `Optional[String[1]]`

gid to use for mailboxes
must matche dovecot.conf AND Postfix virtual_gid_maps parameter
defaults to undef (not included in query)

Default value: `undef`

##### <a name="-postfixadmin--queries--dovecot--quota"></a>`quota`

Data type: `Boolean`

if true quota is included in the query
defaults to true

Default value: `true`

### <a name="postfixadmin--queries--postfix"></a>`postfixadmin::queries::postfix`

class to create mysql maps for postfix

#### Parameters

The following parameters are available in the `postfixadmin::queries::postfix` class:

* [`dbpass`](#-postfixadmin--queries--postfix--dbpass)
* [`dbuser`](#-postfixadmin--queries--postfix--dbuser)
* [`dbname`](#-postfixadmin--queries--postfix--dbname)
* [`hosts`](#-postfixadmin--queries--postfix--hosts)
* [`dir`](#-postfixadmin--queries--postfix--dir)
* [`owner`](#-postfixadmin--queries--postfix--owner)
* [`group`](#-postfixadmin--queries--postfix--group)
* [`mode`](#-postfixadmin--queries--postfix--mode)
* [`allow_account_as_sender`](#-postfixadmin--queries--postfix--allow_account_as_sender)

##### <a name="-postfixadmin--queries--postfix--dbpass"></a>`dbpass`

Data type: `String`

password to connect to the database.

Default value: `'CHANGEME'`

##### <a name="-postfixadmin--queries--postfix--dbuser"></a>`dbuser`

Data type: `String`

username to connect to the database.
defaults to: 'postfixadmin'

Default value: `'postfixadmin'`

##### <a name="-postfixadmin--queries--postfix--dbname"></a>`dbname`

Data type: `String`

name of the database
defaults to: 'postfixadmin'

Default value: `'postfixadmin'`

##### <a name="-postfixadmin--queries--postfix--hosts"></a>`hosts`

Data type: `Array`

Array of hosts to connect to.
defaults to ['localhost']

Default value: `['localhost']`

##### <a name="-postfixadmin--queries--postfix--dir"></a>`dir`

Data type: `String`

directory to place the map

Default value: `'/etc/postfix/postfixadmin'`

##### <a name="-postfixadmin--queries--postfix--owner"></a>`owner`

Data type: `String`

owner of the map files

Default value: `'root'`

##### <a name="-postfixadmin--queries--postfix--group"></a>`group`

Data type: `String`

group of the map files

Default value: `'postfix'`

##### <a name="-postfixadmin--queries--postfix--mode"></a>`mode`

Data type: `String`

mode of the map files

Default value: `'0640'`

##### <a name="-postfixadmin--queries--postfix--allow_account_as_sender"></a>`allow_account_as_sender`

Data type: `Boolean`

used for mysql_sender_access if set to true
add the account as a permitted sender address.
this allows to create send only accounts which do not
receive any mails (eg. sender address is aliased to another
mailbox). Accounts needs to be formated as email adresses for
this to work !

Default value: `false`

### <a name="postfixadmin--vhost"></a>`postfixadmin::vhost`

This class chooses the type of vhost
to run webserver

#### Parameters

The following parameters are available in the `postfixadmin::vhost` class:

* [`vhosttype`](#-postfixadmin--vhost--vhosttype)
* [`servername`](#-postfixadmin--vhost--servername)
* [`serveraliases`](#-postfixadmin--vhost--serveraliases)
* [`docroot`](#-postfixadmin--vhost--docroot)
* [`ssl`](#-postfixadmin--vhost--ssl)
* [`ssl_cert`](#-postfixadmin--vhost--ssl_cert)
* [`ssl_key`](#-postfixadmin--vhost--ssl_key)
* [`ssl_chain`](#-postfixadmin--vhost--ssl_chain)
* [`port`](#-postfixadmin--vhost--port)
* [`redirect_to_ssl`](#-postfixadmin--vhost--redirect_to_ssl)
* [`create_resources`](#-postfixadmin--vhost--create_resources)

##### <a name="-postfixadmin--vhost--vhosttype"></a>`vhosttype`

Data type: `String`

type of vhost to run. currently only apache supported (default)

Default value: `'apache'`

##### <a name="-postfixadmin--vhost--servername"></a>`servername`

Data type: `String`

Servername (defaults to $::fqdn)

Default value: `$facts['networking']['fqdn']`

##### <a name="-postfixadmin--vhost--serveraliases"></a>`serveraliases`

Data type: `Array`

Array of Serveraliasess to listen to (default [])

Default value: `[]`

##### <a name="-postfixadmin--vhost--docroot"></a>`docroot`

Data type: `String`

Document root

Default value: `'/usr/share/postfixadmin'`

##### <a name="-postfixadmin--vhost--ssl"></a>`ssl`

Data type: `Boolean`

If true, use ssl (defaults to false)
If true, you also need to set cert, key and chain.

Default value: `false`

##### <a name="-postfixadmin--vhost--ssl_cert"></a>`ssl_cert`

Data type: `Optional[Stdlib::Absolutepath]`

ssl cert to use

Default value: `undef`

##### <a name="-postfixadmin--vhost--ssl_key"></a>`ssl_key`

Data type: `Optional[Stdlib::Absolutepath]`

ssl key to use

Default value: `undef`

##### <a name="-postfixadmin--vhost--ssl_chain"></a>`ssl_chain`

Data type: `Optional[Stdlib::Absolutepath]`

ssl chain to use

Default value: `undef`

##### <a name="-postfixadmin--vhost--port"></a>`port`

Data type: `Integer`

port to use (default 443)

Default value: `443`

##### <a name="-postfixadmin--vhost--redirect_to_ssl"></a>`redirect_to_ssl`

Data type: `Boolean`

if true, redirects all non https requests to https
defaults to true.

Default value: `true`

##### <a name="-postfixadmin--vhost--create_resources"></a>`create_resources`

Data type: `Hash`

a Hash of Hashes to create additional resources eg. to
retrieve a certificate.
Defaults to {} (do not create any additional resources)
Example (hiera):

postfixadmin::vhost::create_resources:
    sslcert::get_cert:
        get_my_postfix_cert:
          private_key_path: '/etc/postfixadmin/ssl/key.pem'
          cert_path: '/etc/postfixadmin/ssl/cert.pem'

Will result in  executing:

sslcert::get_cert{'get_my_postfix_cert':
  private_key_path => '/etc/postfixadmin/ssl/key.pem'
  cert_path        => '/etc/postfixadmin/ssl/cert.pem'
}

Default value: `{}`

### <a name="postfixadmin--vhost--apache"></a>`postfixadmin::vhost::apache`

internal class that installs an apache vhost
Parameters are inherited from postfixadmin::vhost

#### Parameters

The following parameters are available in the `postfixadmin::vhost::apache` class:

* [`servername`](#-postfixadmin--vhost--apache--servername)
* [`serveraliases`](#-postfixadmin--vhost--apache--serveraliases)
* [`docroot`](#-postfixadmin--vhost--apache--docroot)
* [`apache_vhost`](#-postfixadmin--vhost--apache--apache_vhost)
* [`ssl`](#-postfixadmin--vhost--apache--ssl)
* [`ssl_cert`](#-postfixadmin--vhost--apache--ssl_cert)
* [`ssl_key`](#-postfixadmin--vhost--apache--ssl_key)
* [`ssl_chain`](#-postfixadmin--vhost--apache--ssl_chain)
* [`port`](#-postfixadmin--vhost--apache--port)
* [`redirect_to_ssl`](#-postfixadmin--vhost--apache--redirect_to_ssl)

##### <a name="-postfixadmin--vhost--apache--servername"></a>`servername`

Data type: `String`



Default value: `$postfixadmin::vhost::servername`

##### <a name="-postfixadmin--vhost--apache--serveraliases"></a>`serveraliases`

Data type: `Array`



Default value: `$postfixadmin::vhost::serveraliases`

##### <a name="-postfixadmin--vhost--apache--docroot"></a>`docroot`

Data type: `String`



Default value: `$postfixadmin::vhost::docroot`

##### <a name="-postfixadmin--vhost--apache--apache_vhost"></a>`apache_vhost`

Data type: `Hash`



Default value: `{}`

##### <a name="-postfixadmin--vhost--apache--ssl"></a>`ssl`

Data type: `Boolean`



Default value: `$postfixadmin::vhost::ssl`

##### <a name="-postfixadmin--vhost--apache--ssl_cert"></a>`ssl_cert`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `$postfixadmin::vhost::ssl_cert`

##### <a name="-postfixadmin--vhost--apache--ssl_key"></a>`ssl_key`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `$postfixadmin::vhost::ssl_key`

##### <a name="-postfixadmin--vhost--apache--ssl_chain"></a>`ssl_chain`

Data type: `Optional[Stdlib::Absolutepath]`



Default value: `$postfixadmin::vhost::ssl_chain`

##### <a name="-postfixadmin--vhost--apache--port"></a>`port`

Data type: `Integer`



Default value: `$postfixadmin::vhost::port`

##### <a name="-postfixadmin--vhost--apache--redirect_to_ssl"></a>`redirect_to_ssl`

Data type: `Boolean`



Default value: `$postfixadmin::vhost::redirect_to_ssl`

## Defined types

### <a name="postfixadmin--cli--create_admin"></a>`postfixadmin::cli::create_admin`

This define just ensures that a
an admin account exists.

#### Parameters

The following parameters are available in the `postfixadmin::cli::create_admin` defined type:

* [`admin`](#-postfixadmin--cli--create_admin--admin)
* [`password`](#-postfixadmin--cli--create_admin--password)
* [`superadmin`](#-postfixadmin--cli--create_admin--superadmin)
* [`send_mail`](#-postfixadmin--cli--create_admin--send_mail)

##### <a name="-postfixadmin--cli--create_admin--admin"></a>`admin`

Data type: `String`

the name of the admin account (needs to be an Email)
Defaults to $title

Default value: `$title`

##### <a name="-postfixadmin--cli--create_admin--password"></a>`password`

Data type: `Optional[String[1]]`

The passord to initialy set. If set to undef (the default) an
random password is generated

Default value: `undef`

##### <a name="-postfixadmin--cli--create_admin--superadmin"></a>`superadmin`

Data type: `Boolean`

if set to true the admin is a superadmin with access to all domains
Default to false

Default value: `false`

##### <a name="-postfixadmin--cli--create_admin--send_mail"></a>`send_mail`

Data type: `Boolean`

if true, a mail to $admin is sent with password and url

Default value: `false`

### <a name="postfixadmin--cli--create_aliasdomain"></a>`postfixadmin::cli::create_aliasdomain`

define to ensure an aliasdomain exists

#### Parameters

The following parameters are available in the `postfixadmin::cli::create_aliasdomain` defined type:

* [`target_domain`](#-postfixadmin--cli--create_aliasdomain--target_domain)
* [`domain`](#-postfixadmin--cli--create_aliasdomain--domain)
* [`create_domain`](#-postfixadmin--cli--create_aliasdomain--create_domain)

##### <a name="-postfixadmin--cli--create_aliasdomain--target_domain"></a>`target_domain`

Data type: `String`

the domain it points to

##### <a name="-postfixadmin--cli--create_aliasdomain--domain"></a>`domain`

Data type: `String`

the domain to ensure (defaults to $title)

Default value: `$title`

##### <a name="-postfixadmin--cli--create_aliasdomain--create_domain"></a>`create_domain`

Data type: `Boolean`

if true (default) we use postfixadmin::cli::create_domain
to create the domain.
if you set this to false you need to create the domain
before using this define.

Default value: `true`

### <a name="postfixadmin--cli--create_domain"></a>`postfixadmin::cli::create_domain`

Ensures, that a domain exists
But does not modify any domains

#### Parameters

The following parameters are available in the `postfixadmin::cli::create_domain` defined type:

* [`domain`](#-postfixadmin--cli--create_domain--domain)
* [`description`](#-postfixadmin--cli--create_domain--description)
* [`aliases`](#-postfixadmin--cli--create_domain--aliases)
* [`mailboxes`](#-postfixadmin--cli--create_domain--mailboxes)
* [`quota`](#-postfixadmin--cli--create_domain--quota)
* [`maxquota`](#-postfixadmin--cli--create_domain--maxquota)
* [`default_aliases`](#-postfixadmin--cli--create_domain--default_aliases)

##### <a name="-postfixadmin--cli--create_domain--domain"></a>`domain`

Data type: `String`

The domain defaults to $title

Default value: `$title`

##### <a name="-postfixadmin--cli--create_domain--description"></a>`description`

Data type: `String`

a description defaults to $title

Default value: `$title`

##### <a name="-postfixadmin--cli--create_domain--aliases"></a>`aliases`

Data type: `Integer`

amount of Aliases (-1=disable, 0=unlimited)
defaults to false (do not use option)

Default value: `-1`

##### <a name="-postfixadmin--cli--create_domain--mailboxes"></a>`mailboxes`

Data type: `Integer`

amount of mailboxes (-1=disable, 0=unlimited)
defaults to false (do not use option)

Default value: `-1`

##### <a name="-postfixadmin--cli--create_domain--quota"></a>`quota`

Data type: `Integer`

domain quota (MB | -1 = disable | 0 = unlimited)
defaults to false (do not use option)

Default value: `-1`

##### <a name="-postfixadmin--cli--create_domain--maxquota"></a>`maxquota`

Data type: `Integer`

Mailbox Quota (MB) (MB | -1 = disable | 0 = unlimited)
defaults to false (do not use option)

Default value: `-1`

##### <a name="-postfixadmin--cli--create_domain--default_aliases"></a>`default_aliases`

Data type: `Boolean`

If true (default) set the default aliases

Default value: `true`

### <a name="postfixadmin--domain"></a>`postfixadmin::domain`

helper define to create domains

#### Parameters

The following parameters are available in the `postfixadmin::domain` defined type:

* [`domain`](#-postfixadmin--domain--domain)
* [`target_domain`](#-postfixadmin--domain--target_domain)
* [`cli_parameters`](#-postfixadmin--domain--cli_parameters)

##### <a name="-postfixadmin--domain--domain"></a>`domain`

Data type: `String`

The domain name defaults to $title

Default value: `$title`

##### <a name="-postfixadmin--domain--target_domain"></a>`target_domain`

Data type: `Optional[String[1]]`

if set, an alias domain is created, defaults to undef

Default value: `undef`

##### <a name="-postfixadmin--domain--cli_parameters"></a>`cli_parameters`

Data type: `Hash`

additional parameters for postfixadmin::cli::create_domain
or postfixadmin::cli::create_aliasdomain

Default value: `{}`

## Functions

### <a name="postfixadmin_generate_pw"></a>`postfixadmin_generate_pw`

Type: Ruby 3.x API

computes a random password string

#### `postfixadmin_generate_pw()`

computes a random password string

Returns: `String` a random password st

